<template>
  <a :href="pipeline.web_url" class="flex items-center" v-if="pipeline"
    ><UIcon
      class="mr-1"
      name="i-ph-check-circle"
      v-if="pipeline.status == 'success'"
    /><UIcon
      class="mr-1"
      name="i-ph-seal-wavy-warning"
      v-else-if="pipeline.status == 'failed'"
    />{{ pipeline.status }}</a
  >
  <span v-else class="flex items-center"
    ><UIcon class="mr-1" name="i-ph-seal-wavy-warning" />No builds</span
  >
</template>

<script setup lang="ts">
import { Gitlab } from "@gitbeaker/rest";

const props = defineProps<{
  repo: string;
  pipeline?: "latest" | number;
}>();
const client = new Gitlab({
  host: "https://gitlab.com",
  token: useRuntimeConfig().gitlabToken,
});

let pipeline:
  | {
      status: string;
      web_url: string;
    }
  | false;

try {
  pipeline = await client.Pipelines.show(
    props.repo,
    (props.pipeline || "latest") as unknown as number
  );
} catch (err) {
  if ((err as any)?.toString() == "Error: Not Found") {
    pipeline = false;
  } else {
    throw err;
  }
}
</script>
